<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/thread/address_resolver.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d9/d2d/address__resolver_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">address_resolver.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d9/d2d/address__resolver_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef ADDRESS_RESOLVER_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define ADDRESS_RESOLVER_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/dcb/openthread-core-config_8h.html">openthread-core-config.h</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dd/d28/coap__server_8hpp.html">coap/coap_server.hpp</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d05/timer_8hpp.html">common/timer.hpp</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../da/db5/mac_8hpp.html">mac/mac.hpp</a>&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/dba/icmp6_8hpp.html">net/icmp6.hpp</a>&gt;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/db7/udp6_8hpp.html">net/udp6.hpp</a>&gt;</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">class </span>MeshForwarder;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">class </span>ThreadLastTransactionTimeTlv;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">class </span>ThreadMeshLocalEidTlv;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">class </span>ThreadNetif;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">class </span>ThreadTargetTlv;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="../../d4/dcf/classThread_1_1AddressResolver.html">   66</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html">AddressResolver</a></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;{</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">explicit</span> <a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html#a178438299a058ea03995b643ddd6aa72">AddressResolver</a>(<a class="code" href="../../d3/d8e/classThread_1_1ThreadNetif.html">ThreadNetif</a> &amp;aThreadNetif);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html#af9e813b464854994a8beda21d91c989c">Clear</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html#aa818018b3ba3f64d241090f52591ddb9">GetEntry</a>(uint8_t aIndex, <a class="code" href="../../d7/d52/structotEidCacheEntry.html">otEidCacheEntry</a> &amp;aEntry) <span class="keyword">const</span>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html#adee9bd68079de5acd345ad154d54880c">Remove</a>(uint8_t aRouterId);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940">Resolve</a>(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aEid, <a class="code" href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">Mac::ShortAddress</a> &amp;aRloc16);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    {</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        kCacheEntries = <a class="code" href="../../d7/d08/openthread-core-default-config_8h.html#af84464acfb218da6d12faa62e1316664">OPENTHREAD_CONFIG_ADDRESS_CACHE_ENTRIES</a>,</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        kStateUpdatePeriod = 1000u,           </div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    };</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    {</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        kAddressQueryTimeout = 3,             </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        kAddressQueryInitialRetryDelay = 15,  </div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        kAddressQueryMaxRetryDelay = 28800,   </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    };</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keyword">struct </span>Cache</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    {</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a>      mTarget;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        uint8_t           mMeshLocalIid[<a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#acbc13cfb9a17025f1f57051f71dd4f00a4141f36de1ffc17734ac73ffce2f592b">Ip6::Address::kInterfaceIdentifierSize</a>];</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        uint32_t          mLastTransactionTime;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <a class="code" href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">Mac::ShortAddress</a> mRloc16;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        uint16_t          mRetryTimeout;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        uint8_t           mTimeout;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        uint8_t           mFailures;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keyword">enum</span> State</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            kStateInvalid,</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            kStateQuery,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            kStateCached,</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        };</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        State             mState;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    };</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendAddressQuery(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aEid);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendAddressError(<span class="keyword">const</span> <a class="code" href="../../df/d0b/classThread_1_1ThreadTargetTlv.html">ThreadTargetTlv</a> &amp;aTarget, <span class="keyword">const</span> <a class="code" href="../../df/d0c/classThread_1_1ThreadMeshLocalEidTlv.html">ThreadMeshLocalEidTlv</a> &amp;aEid,</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                                 <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> *aDestination);</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordtype">void</span> SendAddressQueryResponse(<span class="keyword">const</span> <a class="code" href="../../df/d0b/classThread_1_1ThreadTargetTlv.html">ThreadTargetTlv</a> &amp;aTargetTlv, <span class="keyword">const</span> <a class="code" href="../../df/d0c/classThread_1_1ThreadMeshLocalEidTlv.html">ThreadMeshLocalEidTlv</a> &amp;aMlEidTlv,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                                  <span class="keyword">const</span> <a class="code" href="../../dc/dc8/classThread_1_1ThreadLastTransactionTimeTlv.html">ThreadLastTransactionTimeTlv</a> *aLastTransactionTimeTlv,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;                                  <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aDestination);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordtype">void</span> SendAddressErrorResponse(<span class="keyword">const</span> <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aRequestHeader, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aRequestInfo);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordtype">void</span> SendAddressNotificationResponse(<span class="keyword">const</span> <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aRequestHeader, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aRequestInfo);</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleUdpReceive(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a> aMessage, <span class="keyword">const</span> <a class="code" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a> *aMessageInfo);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleAddressError(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader,</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                                   <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordtype">void</span> HandleAddressError(<a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleAddressQuery(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                                   <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordtype">void</span> HandleAddressQuery(<a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleAddressNotification(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                                          <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="keywordtype">void</span> HandleAddressNotification(<a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleDstUnreach(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo,</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                                 <span class="keyword">const</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">Ip6::IcmpHeader</a> &amp;aIcmpHeader);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordtype">void</span> HandleDstUnreach(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo, <span class="keyword">const</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">Ip6::IcmpHeader</a> &amp;aIcmpHeader);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleTimer(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keywordtype">void</span> HandleTimer(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <a class="code" href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Coap::Resource</a> mAddressError;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <a class="code" href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Coap::Resource</a> mAddressQuery;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <a class="code" href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Coap::Resource</a> mAddressNotification;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    Cache mCache[kCacheEntries];</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    uint16_t mCoapMessageId;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">Ip6::IcmpHandler</a> mIcmpHandler;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <a class="code" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">Ip6::UdpSocket</a> mSocket;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> mTimer;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <a class="code" href="../../dd/d1d/classThread_1_1MeshForwarder.html">MeshForwarder</a> &amp;mMeshForwarder;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <a class="code" href="../../de/d76/classThread_1_1Coap_1_1Server.html">Coap::Server</a> &amp;mCoapServer;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <a class="code" href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">Mle::MleRouter</a> &amp;mMle;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <a class="code" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html">Ip6::Netif</a> &amp;mNetif;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;};</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="preprocessor">#endif  // ADDRESS_RESOLVER_HPP_</span></div><div class="ttc" id="classThread_1_1Ip6_1_1MessageInfo_html"><div class="ttname"><a href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Thread::Ip6::MessageInfo</a></div><div class="ttdoc">This class implements message information for an IPv6 message. </div><div class="ttdef"><b>Definition:</b> socket.hpp:54</div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html_ac249179518a77ecfdaf7d4502ef2f940"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940">Thread::AddressResolver::Resolve</a></div><div class="ttdeci">ThreadError Resolve(const Ip6::Address &amp;aEid, Mac::ShortAddress &amp;aRloc16)</div><div class="ttdoc">This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k...</div><div class="ttdef"><b>Definition:</b> address_resolver.cpp:105</div></div>
<div class="ttc" id="classThread_1_1Message_html"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html">Thread::Message</a></div><div class="ttdoc">This class represents a message. </div><div class="ttdef"><b>Definition:</b> message.hpp:213</div></div>
<div class="ttc" id="classThread_1_1ThreadTargetTlv_html"><div class="ttname"><a href="../../df/d0b/classThread_1_1ThreadTargetTlv.html">Thread::ThreadTargetTlv</a></div><div class="ttdoc">This class implements Target EID TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> thread_tlvs.hpp:133</div></div>
<div class="ttc" id="classThread_1_1ThreadNetif_html"><div class="ttname"><a href="../../d3/d8e/classThread_1_1ThreadNetif.html">Thread::ThreadNetif</a></div><div class="ttdef"><b>Definition:</b> thread_netif.hpp:85</div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html_adee9bd68079de5acd345ad154d54880c"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html#adee9bd68079de5acd345ad154d54880c">Thread::AddressResolver::Remove</a></div><div class="ttdeci">void Remove(uint8_t aRouterId)</div><div class="ttdoc">This method removes a Router ID from the EID-to-RLOC cache. </div><div class="ttdef"><b>Definition:</b> address_resolver.cpp:94</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="group__core-mac_html_ga70635fe32761138510f029f3d4eb36b7"><div class="ttname"><a href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">Thread::Mac::ShortAddress</a></div><div class="ttdeci">otShortAddress ShortAddress</div><div class="ttdoc">This type represents the IEEE 802.15.4 Short Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:75</div></div>
<div class="ttc" id="classThread_1_1Timer_html"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html">Thread::Timer</a></div><div class="ttdoc">This class implements a timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:138</div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html_aa818018b3ba3f64d241090f52591ddb9"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html#aa818018b3ba3f64d241090f52591ddb9">Thread::AddressResolver::GetEntry</a></div><div class="ttdeci">ThreadError GetEntry(uint8_t aIndex, otEidCacheEntry &amp;aEntry) const </div><div class="ttdoc">This method gets an EID cache entry. </div><div class="ttdef"><b>Definition:</b> address_resolver.cpp:81</div></div>
<div class="ttc" id="udp6_8hpp_html"><div class="ttname"><a href="../../d0/db7/udp6_8hpp.html">udp6.hpp</a></div><div class="ttdoc">This file includes definitions for UDP/IPv6 sockets. </div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html">Thread::AddressResolver</a></div><div class="ttdoc">This class implements the EID-to-RLOC mapping and caching. </div><div class="ttdef"><b>Definition:</b> address_resolver.hpp:66</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Netif_html"><div class="ttname"><a href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html">Thread::Ip6::Netif</a></div><div class="ttdoc">This class implements an IPv6 network interface. </div><div class="ttdef"><b>Definition:</b> netif.hpp:228</div></div>
<div class="ttc" id="classThread_1_1MeshForwarder_html"><div class="ttname"><a href="../../dd/d1d/classThread_1_1MeshForwarder.html">Thread::MeshForwarder</a></div><div class="ttdoc">This class implements mesh forwarding within Thread. </div><div class="ttdef"><b>Definition:</b> mesh_forwarder.hpp:70</div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Header_html"><div class="ttname"><a href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Thread::Coap::Header</a></div><div class="ttdoc">This class implements CoAP header generation and parsing. </div><div class="ttdef"><b>Definition:</b> coap_header.hpp:68</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">Thread::Ip6::IcmpHeader</a></div><div class="ttdoc">This class implements ICMPv6 header generation and parsing. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:83</div></div>
<div class="ttc" id="coap__server_8hpp_html"><div class="ttname"><a href="../../dd/d28/coap__server_8hpp.html">coap_server.hpp</a></div><div class="ttdoc">This file includes definitions for the CoAP server. </div></div>
<div class="ttc" id="classThread_1_1ThreadMeshLocalEidTlv_html"><div class="ttname"><a href="../../df/d0c/classThread_1_1ThreadMeshLocalEidTlv.html">Thread::ThreadMeshLocalEidTlv</a></div><div class="ttdoc">This class implements ML-EID TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> thread_tlvs.hpp:261</div></div>
<div class="ttc" id="openthread-core-default-config_8h_html_af84464acfb218da6d12faa62e1316664"><div class="ttname"><a href="../../d7/d08/openthread-core-default-config_8h.html#af84464acfb218da6d12faa62e1316664">OPENTHREAD_CONFIG_ADDRESS_CACHE_ENTRIES</a></div><div class="ttdeci">#define OPENTHREAD_CONFIG_ADDRESS_CACHE_ENTRIES</div><div class="ttdoc">The number of EID-to-RLOC cache entries. </div><div class="ttdef"><b>Definition:</b> openthread-core-default-config.h:95</div></div>
<div class="ttc" id="mac_8hpp_html"><div class="ttname"><a href="../../da/db5/mac_8hpp.html">mac.hpp</a></div><div class="ttdoc">This file includes definitions for the IEEE 802.15.4 MAC. </div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Resource_html"><div class="ttname"><a href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Thread::Coap::Resource</a></div><div class="ttdoc">This class implements CoAP resource handling. </div><div class="ttdef"><b>Definition:</b> coap_server.hpp:55</div></div>
<div class="ttc" id="structotEidCacheEntry_html"><div class="ttname"><a href="../../d7/d52/structotEidCacheEntry.html">otEidCacheEntry</a></div><div class="ttdoc">This structure represents an EID cache entry. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:771</div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html_af9e813b464854994a8beda21d91c989c"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html#af9e813b464854994a8beda21d91c989c">Thread::AddressResolver::Clear</a></div><div class="ttdeci">void Clear(void)</div><div class="ttdoc">This method clears the EID-to-RLOC cache. </div><div class="ttdef"><b>Definition:</b> address_resolver.cpp:76</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1UdpSocket_html"><div class="ttname"><a href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">Thread::Ip6::UdpSocket</a></div><div class="ttdoc">This class implements a UDP/IPv6 socket. </div><div class="ttdef"><b>Definition:</b> udp6.hpp:59</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHandler_html"><div class="ttname"><a href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">Thread::Ip6::IcmpHandler</a></div><div class="ttdoc">This class implements ICMPv6 message handlers. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:213</div></div>
<div class="ttc" id="timer_8hpp_html"><div class="ttname"><a href="../../df/d05/timer_8hpp.html">timer.hpp</a></div><div class="ttdoc">This file includes definitions for the multiplexed timer service. </div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Server_html"><div class="ttname"><a href="../../de/d76/classThread_1_1Coap_1_1Server.html">Thread::Coap::Server</a></div><div class="ttdoc">This class implements the CoAP server. </div><div class="ttdef"><b>Definition:</b> coap_server.hpp:101</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html_acbc13cfb9a17025f1f57051f71dd4f00a4141f36de1ffc17734ac73ffce2f592b"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#acbc13cfb9a17025f1f57051f71dd4f00a4141f36de1ffc17734ac73ffce2f592b">Thread::Ip6::Address::kInterfaceIdentifierSize</a></div><div class="ttdoc">Interface Identifier size in bytes. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:65</div></div>
<div class="ttc" id="structotMessageInfo_html"><div class="ttname"><a href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a></div><div class="ttdoc">This structure represents the local and peer IPv6 socket addresses. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:902</div></div>
<div class="ttc" id="classThread_1_1ThreadLastTransactionTimeTlv_html"><div class="ttname"><a href="../../dc/dc8/classThread_1_1ThreadLastTransactionTimeTlv.html">Thread::ThreadLastTransactionTimeTlv</a></div><div class="ttdoc">This class implements Time Since Last Transaction TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> thread_tlvs.hpp:359</div></div>
<div class="ttc" id="classThread_1_1AddressResolver_html_a178438299a058ea03995b643ddd6aa72"><div class="ttname"><a href="../../d4/dcf/classThread_1_1AddressResolver.html#a178438299a058ea03995b643ddd6aa72">Thread::AddressResolver::AddressResolver</a></div><div class="ttdeci">AddressResolver(ThreadNetif &amp;aThreadNetif)</div><div class="ttdoc">This constructor initializes the object. </div><div class="ttdef"><b>Definition:</b> address_resolver.cpp:54</div></div>
<div class="ttc" id="group__messages_html_ga461fb1347aeb99b1d4aab520915e121e"><div class="ttname"><a href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a></div><div class="ttdeci">void * otMessage</div><div class="ttdoc">This type points to an OpenThread message buffer. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:872</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="classThread_1_1Mle_1_1MleRouter_html"><div class="ttname"><a href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">Thread::Mle::MleRouter</a></div><div class="ttdoc">This class implements MLE functionality required by the Thread Router and Leader roles. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:174</div></div>
<div class="ttc" id="icmp6_8hpp_html"><div class="ttname"><a href="../../d0/dba/icmp6_8hpp.html">icmp6.hpp</a></div><div class="ttdoc">This file includes definitions for ICMPv6. </div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="openthread-core-config_8h_html"><div class="ttname"><a href="../../df/dcb/openthread-core-config_8h.html">openthread-core-config.h</a></div><div class="ttdoc">This file includes compile-time configuration constants for OpenThread. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_fd71accbf528c1576ca21e7ec5716833.html">thread</a></li><li class="navelem"><a class="el" href="../../d9/d2d/address__resolver_8hpp.html">address_resolver.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
